﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WpfApplication2
{
    class Meeting
    {
        DateTime when;
        TimeSpan duration;
        string title;

        //18
        static int totalNumber;
        static TimeSpan totalDuration;

        public Meeting()
        {
            when = DateTime.Now;
            duration = TimeSpan.FromHours(2.0);
            title = "Unbenannt";
            // 18
            totalNumber++;
            totalDuration += duration;
        }

        public Meeting(double hours)
        {
            when = DateTime.Now;
            duration = TimeSpan.FromHours(hours);
            title = "Unbenannt";
            // 18
            totalNumber++;
            totalDuration += duration;
        }

        public Meeting(DateTime when, TimeSpan duration, string title)
        {
            this.when = when;
            this.duration = duration;
            this.title = title;
            // 18
            totalNumber++;
            totalDuration += duration;
        }

        public bool IsNow()
        {
            DateTime now = DateTime.Now;
            return when <= now && now <= when + duration;
        }

        public void Postpone(double hours)
        {
            when += TimeSpan.FromHours(hours);
        }

        public void Postpone(TimeSpan ts)
        {
            when += ts;
        }

        public TimeSpan Duration
        {
            get
            {
                return duration;
            }
            set
            {
                duration = value;
            }
        }

        public DateTime When
        {
            get
            {
                return when;
            }
            set
            {
                when = value;
            }
        }

        //18
        static public int TotalNumber
        {
            get { return totalNumber; }
        }
        static public TimeSpan TotalDuration
        {
            get { return totalDuration; }
        }
        static public double GetAverageDuration()
        {
            // TODO: Was tun, wenn TotalNumber == 0?
            return TotalDuration.TotalHours / TotalNumber;
        }
    }
}
